=== libgxwmm/wscript ===
#! /usr/bin/env python
# encoding: utf-8

def configure(conf):
    conf.recurse('gxwmm');

def build(bld):
    env = bld.env
    if not (env.STANDALONE or env.NEW_LADSPA):
        return
    bld.recurse('gxwmm')
    if env.NEW_LADSPA:
        return
    bld.add_group()
    prog = bld(features = 'cxx cprogram',
               source = 'gxw_demo.cc',
               target = 'gxw_demo',
               use = ['GTKMM','gxwmm'],
               includes = ['.'],
               install_path = None,
               )
