=== debian/changelog ===
guitarix (0.46.0+dfsg-2) unstable; urgency=medium

  * Team upload
  * Stop building glade catalog support

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 15 Aug 2025 13:39:42 -0400

guitarix (0.46.0+dfsg-1) unstable; urgency=medium

  * New upstream version 0.46.0+dfsg
    + Fix segfaults, when creating a preset bank (Closes: #1062831)
  * Development switched to github, update d/copyright and d/watch
  * LADSPA support is dropped, remove ladspa package
  * Drop patches applied by upstream
  * Add libfftw3-dev to B-Ds
  * Bump d/copyright years
  * Refresh *.lintian.overrides, add d/source/lintian-overrides

 -- Dennis Braun <snd@debian.org>  Fri, 29 Mar 2024 17:15:09 +0100

guitarix (0.44.1+dfsg1-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062195

 -- Lukas Märdian <slyon@debian.org>  Wed, 28 Feb 2024 09:01:17 +0000
